"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var schema_1 = require("../schema");
schema_1.Schema.prototype.strictProperties = function (strictProperties) {
    var optional = this.getState('optional'), strictKeys = Object.keys(strictProperties).filter(function (p) {
        return !optional || optional.indexOf(p) < 0;
    });
    return (_a = this
        .properties(strictProperties)
        .additionalProperties(false)).required.apply(_a, strictKeys);
    var _a;
};
schema_1.Schema.prototype.optional = function () {
    var properties = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        properties[_i] = arguments[_i];
    }
    this.setState('optional', properties);
    var props = this.props, existingRequireds = props && props.required;
    if (Array.isArray(existingRequireds)) {
        properties.forEach(function (property) {
            var existingIndex = existingRequireds.indexOf(property);
            if (existingIndex !== -1) {
                existingRequireds.splice(existingIndex, 1);
            }
        });
    }
    return this;
};
exports.strictProperties = [];
