"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var schema_1 = require("../schema");
schema_1.Schema.prototype.trim = function (trim) {
    if (trim === void 0) { trim = true; }
    return this.setProps({ trim: trim });
};
exports.trim = {
    name: 'trim',
    modifying: true,
    validate: function (schema, data, parentSchema, dataPath, parentData, parentDataProperty, rootData) {
        if (typeof data === 'string' && parentData !== undefined && parentDataProperty !== undefined) {
            var trimmedString = data.trim();
            parentData[parentDataProperty] = trimmedString;
        }
        return true;
    }
};
