"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var schema_1 = require("../schema");
schema_1.Schema.prototype.allowNull = function () {
    var props = this.props, enums = props.enum;
    var type = props.type;
    if (Array.isArray(enums) && !enums.includes(null)) {
        enums.push(null);
    }
    if (!type || type === 'null') {
        return this;
    }
    if (!Array.isArray(type)) {
        type = [type];
    }
    if (!type.includes('null')) {
        type.push('null');
    }
    return this.setProps({ type: type });
};
exports.allowNull = [];
