"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var schema_1 = require("./schema");
var util_1 = require("./util");
var schema_2 = require("./schema");
exports.Schema = schema_2.Schema;
var validator_1 = require("./validator");
exports.Validator = validator_1.Validator;
exports.ValidationError = validator_1.ValidationError;
exports.schema = new schema_1.Schema(), exports.number = exports.schema.type('number'), exports.integer = exports.schema.type('integer'), exports.string = exports.schema.type('string'), exports.boolean = exports.schema.type('boolean'), exports.array = util_1.callableInstance(exports.schema.type('array'), 'items'), exports.object = util_1.callableInstance(exports.schema.type('object'), 'properties');
